<script lang="ts">
  import CardIcon from "./lib/icons/CardIcon.svelte";
  import { CardType } from "./lib/utils";

  export let state: Server.PublicState;

  $: playerCount = state[1].length;
  $: startingHandSize = ((playerCount) => {
    switch (playerCount) {
      case 5:
        return 7;
      case 4:
        return 8;
      case 3:
        return 9;
      default:
        return 10;
    }
  })(playerCount);
</script>

<div class="reference panel">
  <p>
    In a {playerCount} player game, each player is dealt
    <strong>{startingHandSize}</strong> cards each round.
  </p>

  <h3>On your turn</h3>
  <p>
    Pick one card in your hand you would like to keep. Players pick cards
    simultaneously, and the picked cards are revealed after every player has
    picked.
  </p>

  <p>
    Players then pass the remaining cards in their hand to the player to their
    left.
  </p>

  <p>Repeat this process until every card has been picked.</p>

  <h3>End of the round</h3>

  <p>
    The round ends when every card in the players' hands has been picked. The
    player's then score points based on the cards they have picked.
  </p>

  <p>
    Then, another round begins. All picked cards are removed (except
    <strong>Dessert</strong> cards), and each player is dealt another hand from the
    deck.
  </p>

  <p>A total of <strong>3</strong> rounds are played.</p>

  <h3>End of the game</h3>

  <p>
    The game ends after the 3rd round. The round is scored normally, with the
    addition of scoring <strong>Dessert</strong> cards.
  </p>

  <p>The player with the most points wins!</p>

  <h3 id="scoring">Cards and scoring</h3>
  <dl>
    <dt class="relative">
      Rice Balls

      <div class="card-value-counts">
        {#each [[3, 8], [2, 12], [1, 6]] as [value, count]}
          <span>
            <strong class="card-value">{value}</strong><CardIcon
              inline
              suit={CardType.RiceBall}
            />&times;&ThinSpace;{count}
          </span>
        {/each}
      </div>
    </dt>
    <dd>
      Most = 6 points<br />
      Second most = 3 points
      <p>
        Tied players split points evenly (rounded down). If there is a tie for
        most, no points are awarded for second most.
      </p>
    </dd>

    <dt>
      Tempura
      <span class="card-count">
        <CardIcon inline suit={CardType.Tempura} />&times;&ThinSpace;14
      </span>
    </dt>
    <dd>5 points for every set of 2.</dd>

    <dt>
      Dango
      <span class="card-count">
        <CardIcon inline suit={CardType.Dango} />&times;&ThinSpace;14
      </span>
    </dt>
    <dd>10 points for every set of 3.</dd>

    <dt>
      Gyoza
      <span class="card-count">
        <CardIcon inline suit={CardType.Gyoza} />&times;&ThinSpace;14
      </span>
    </dt>
    <dd>
      &times; 1 = 1 point<br />
      &times; 2 = 3 points<br />
      &times; 3 = 6 points<br />
      &times; 4 = 10 points<br />
      &times; 5+ = 15 points<br />
    </dd>

    <dt>
      Sushi

      <div class="card-value-counts">
        {#each [[3, 5], [2, 10], [1, 5]] as [value, count]}
          <span>
            <strong class="card-value">{value}</strong><CardIcon
              inline
              suit={CardType.Sushi}
            />&times;&ThinSpace;{count}
          </span>
        {/each}
      </div>
    </dt>
    <dd>Number on card denotes point value.</dd>

    <dt>
      Tea
      <span class="card-count">
        <CardIcon inline suit={CardType.Tea} />&times;&ThinSpace;6
      </span>
    </dt>
    <dd>Triples the points of your next <strong>Sushi</strong>.</dd>

    <dt>
      Takeout Box
      <span class="card-count">
        <CardIcon inline suit={CardType.TakeoutBox} />&times;&ThinSpace;4
      </span>
    </dt>
    <dd>Can be used on a later turn to pick two cards instead of one.</dd>

    <dt>
      Dessert
      <span class="card-count">
        <CardIcon inline suit={CardType.Dessert} />&times;&ThinSpace;10
      </span>
    </dt>
    <dd>
      At the end of the game:<br />
      Most desserts = 6 points <br />
      Fewest desserts = &minus;6 points

      <p>Tied players split points evenly (rounded towards zero).</p>
    </dd>
  </dl>
</div>

<style>
  .reference {
    height: 100%;
    font-size: 85%;
    overflow-y: auto;
    background-color: linen;
    padding: 1.5rem;
  }

  h3 {
    margin-top: 1.25em;
    font-weight: 500;
  }
  p {
    margin-top: 0.5em;
    margin-bottom: 1em;
  }
  dt {
    font-weight: 500;
    display: flex;
    justify-content: start;
    align-items: center;
    gap: 1em;
  }

  dl {
    margin: 0;
  }
  dt:not(:first-child) {
    margin-top: 1em;
  }
  dd {
    margin: 0;
  }
  .relative {
    position: relative;
  }
  .card-value-counts {
    font-size: 0.85rem;
    display: flex;
    gap: 1em;
    justify-content: space-between;
    font-weight: 500;
  }
  .card-value {
    display: inline-block;
    font-weight: bolder;
    color: whitesmoke;
    text-shadow: 0 0 1px #2227, 0 0 1px #2227, 0 0 1px #2227, 0 0 1px #2227;

    transform: scale(1.25);
  }

  .card-count {
    font-size: 0.85rem;
    font-weight: 500;
  }
</style>
